// By Berke "STEAM_0:0:95142811"

iMaxClients <- MaxClients(), flGameStartOrigin <- Entities.FindByName(null, "karts1start1").GetOrigin(), flGamePlacementsOriginAngle <- [], iLapLimit <- 3, ::flCheckPointOrigins <- [], hPlayersInStartRoom <- [], PlayersInGame <- [], strFinishedPlayerNames <- [], hGameEntities <- array(9),
flGameEndOriginAngle <-
{
		flOrigin = Entities.FindByName(null, "karts1end1").GetOrigin(),
		flAngles = Entities.FindByName(null, "karts1end1").GetAbsAngles()
};

for (local iOrder = 0; iOrder <= 5; iOrder++)
{
	local iNumber = iOrder + 1;

	flCheckPointOrigins.push(Entities.FindByName(null, "karts1checkpoint" + iNumber).GetOrigin());

	if (iOrder <= 2)
	{
		local hEntity = Entities.FindByName(null, "karts1placement" + iNumber);

		flGamePlacementsOriginAngle.push(
		{
			flOrigin = hEntity.GetOrigin(),
			flAngles = hEntity.GetAbsAngles().y
		});
	}
}

function OnPostSpawn()
{
	__CollectEventCallbacks(this, "OnGameEvent_", "GameEventCallbacks", RegisterScriptGameEventListener);
}

function Think()
{
	CheckPlacement();

	return 1;
}

function CheckPlacement()
{
	PlayersInGame.sort(SortPlacement);

	local strText = "";

	foreach (iOrder, strFinishedPlayerName in strFinishedPlayerNames)
		if (iOrder <= 9)
		{
			if (iOrder)
				strText += "\n";

			strText += iOrder + 1 + ". " + strFinishedPlayerName + " - Finished";
		}

	local strFinishedPlayerNamesLength = strFinishedPlayerNames.len();

	foreach (iOrder, PlayerInGame in PlayersInGame)
	{
		PlayerInGame.flCheckPointDistance = -1;

		local hPlayer = PlayerInGame.hPlayer, iPlacement = strFinishedPlayerNamesLength + iOrder + 1, iLap = PlayerInGame.iLap;

		DisplayMapMessage(hPlayer, iPlacement + GetOrdinalNumberSuffix(iPlacement) + " Place - Lap " + iLap + "/" + iLapLimit);

		if (strFinishedPlayerNamesLength < 10 && iOrder <= 9 - strFinishedPlayerNamesLength)
		{
			if (strFinishedPlayerNamesLength || iOrder)
				strText += "\n";

			strText += iPlacement + ". " + NetProps.GetPropString(hPlayer, "m_szNetname") + " - Lap " + iLap;
		}
	}

	EntFireByHandle(GetWorldText(2), "SetText", strText, 0, null, null);
}

function SortPlacement(First, Second)
{
	local iFirstLap = First.iLap, iSecondLap = Second.iLap, iReturn = 0;

	if (iFirstLap > iSecondLap)
		iReturn = -1;

	else if (iFirstLap < iSecondLap)
		iReturn = 1;

	else
	{
		local iFirstCheckPoint = First.iCheckPoint, iSecondCheckPoint = Second.iCheckPoint;

		if (iFirstCheckPoint > iSecondCheckPoint)
			iReturn = -1;

		else if (iFirstCheckPoint < iSecondCheckPoint)
			iReturn = 1;

		else
		{
			local flCheckPointOrigin =  flCheckPointOrigins[iFirstCheckPoint > 5 ? 0 : iFirstCheckPoint];

			if (First.flCheckPointDistance == -1)
				First.flCheckPointDistance = (First.hPlayer.GetOrigin() - flCheckPointOrigin).Length2D();

			if (Second.flCheckPointDistance == -1)
				Second.flCheckPointDistance = (Second.hPlayer.GetOrigin() - flCheckPointOrigin).Length2D();

			local iFirstCheckPointDistance = First.flCheckPointDistance, iSecondCheckPointDistance = Second.flCheckPointDistance;

			if (iFirstCheckPointDistance < iSecondCheckPointDistance)
				iReturn = -1;

			else if (iFirstCheckPointDistance > iSecondCheckPointDistance)
				iReturn = 1;
		}
	}

    return iReturn;
}

function OnGameEvent_player_death(EventData)
{
	if (!(EventData.death_flags & 1 << 5))
	{
		local hPlayer = GetPlayerFromUserID(EventData.userid);

		foreach (iOrder, PlayerInGame in PlayersInGame)
			if (PlayerInGame.hPlayer == hPlayer)
			{
				PlayersInGame.remove(iOrder);

				break;
			}
	}
}

function OnGameEvent_player_disconnect(EventData)
{
	local hPlayer = GetPlayerFromUserID(EventData.userid), iPlayerIndex = hPlayersInStartRoom.find(hPlayer);

	if (iPlayerIndex != null)
		hPlayersInStartRoom.remove(iPlayerIndex);

	else
		foreach (iOrder, PlayerInGame in PlayersInGame)
			if (PlayerInGame.hPlayer == hPlayer)
			{
				PlayersInGame.remove(iOrder);

				break;
			}
}

function RoundSpawn()
{
	AddThinkToEnt(self, null);

	PlayersInGame.clear();

	strFinishedPlayerNames.clear();

	iLapLimit = 3, hGameEntities = array(9);
}

function IncreaseLaps()
{
	if (iLapLimit <= 4)
	{
		iLapLimit++;

		EntFireByHandle(GetWorldText(1), "SetText", iLapLimit + " Laps", 0, null, null);
	}
}

function DecreaseLaps()
{
	if (iLapLimit > 2)
	{
		iLapLimit--;

		EntFireByHandle(GetWorldText(1), "SetText", iLapLimit + " Laps", 0, null, null);
	}
}

function JoinGame()
{
	hPlayersInStartRoom.push(activator);
}

function LeaveGame()
{
	if (activator.IsValid())
	{
		local iActivatorIndex = hPlayersInStartRoom.find(activator);

		if (iActivatorIndex != null)
			hPlayersInStartRoom.remove(iActivatorIndex);
	}
}

function StartGame()
{
	if (hPlayersInStartRoom.len() < 2)
		PrintMapMessage(activator, "More than \x07C0C0C01\x1 person is required to start this game.");

	else
	{
		EntFireByHandle(caller, "Lock", "", 0, null, null);

		EntFireByHandle(GetButton(3), "Lock", "", 0, null, null);

		EntFireByHandle(GetButton(4), "Lock", "", 0, null, null);

		EntFireByHandle(GetWorldText(2), "SetText", "", 0, null, null);

		strFinishedPlayerNames.clear();

		foreach (hPlayerInStartRoom in hPlayersInStartRoom)
			PlayersInGame.push(
			{
				hPlayer = hPlayerInStartRoom,
				iLap = 1,
				iCheckPoint = 1,
				flCheckPointDistance = -1
			});

		PlayGlobalSound("berke1/jailbreak1/colors1/karts1/start1.mp3");

		PrecacheScriptSound("BumperCar.Bump");
		PrecacheScriptSound("BumperCar.SpeedBoostStart");
		PrecacheScriptSound("BumperCar.SpeedBoostStop");
		PrecacheScriptSound("BumperCar.BumpIntoAir");
		PrecacheScriptSound("BumperCar.BumpHard");
		PrecacheScriptSound("BumperCar.Jump");
		PrecacheScriptSound("BumperCar.JumpLand");

		if (!IsModelPrecached("models/props_halloween/bumpercar_cage.mdl"))
			PrecacheModel("models/props_halloween/bumpercar_cage.mdl");

		local iPlayersInStartRoomLength = 0, iCurrentRow = 0, iCurrentColumn = 0;

		while (iPlayersInStartRoomLength = hPlayersInStartRoom.len())
		{
			local hPlayerInStartRoom = hPlayersInStartRoom.remove(RandomInt(0, iPlayersInStartRoomLength - 1));

			hPlayerInStartRoom.SetAbsAngles(QAngle(0, -90));

			hPlayerInStartRoom.RemoveCond(Constants.ETFCond.TF_COND_TAUNTING);
			hPlayerInStartRoom.AddCond(Constants.ETFCond.TF_COND_HALLOWEEN_KART);
			hPlayerInStartRoom.AddCondEx(Constants.ETFCond.TF_COND_HALLOWEEN_KART_CAGE, 10, null);

			hPlayerInStartRoom.SetAbsOrigin(Vector(flGameStartOrigin.x - 64 * iCurrentRow, flGameStartOrigin.y + 64 * iCurrentColumn, flGameStartOrigin.z));

			if (iCurrentRow <= 4)
				iCurrentRow++;

			else
				iCurrentRow = 0, iCurrentColumn++;

			hPlayerInStartRoom.SetAbsVelocity(Vector());

			EntFireByHandle(GetClientCommand(), "Command", "play berke1/jailbreak1/colors1/karts1/countdown1.mp3", 7.5, hPlayerInStartRoom, null);
		}

		EntFireByHandle(self, "RunScriptCode", "AddThinkToEnt(self, `Think`);", 10, null, null);

		EntFireByHandle(GetMusicPlayer(), "PlaySound", "", 10, null, null);

		EntFireByHandle(GetButton(2), "Unlock", "", 10, null, null);
	}
}

function TouchCheckPoint(iNumber)
{
	foreach (iOrder, PlayerInGame in PlayersInGame)
	{
		local hPlayer = PlayerInGame.hPlayer;

		if (hPlayer == activator)
		{
			switch (iNumber - PlayerInGame.iCheckPoint)
			{
				case -1:
				{
					PlayerInGame.iCheckPoint--;

					CheckPlacement();

					break;
				}

				case 1:
				{
					PlayerInGame.iCheckPoint++;

					CheckPlacement();

					break;
				}

				case -5:
				{
					local iLap = PlayerInGame.iLap;

					if (iLap == iLapLimit)
					{
						ExitPlayer(hPlayer, true);

						local strFinishedPlayerNamesLength = strFinishedPlayerNames.len(), iPlacement = strFinishedPlayerNamesLength + 1, strPlayerName = NetProps.GetPropString(hPlayer, "m_szNetname");

						PrintMapMessage(null, "Player \x07C0C0C0" + strPlayerName + "\x1 finished as \x07C0C0C0" + iPlacement + GetOrdinalNumberSuffix(iPlacement) + "\x1 place!");

						PlayersInGame.remove(iOrder);

						if (!PlayersInGame.len())
							StopGame();

						local hClientCommand = GetClientCommand();

						if (!strFinishedPlayerNamesLength)
							PlayGlobalSound("berke1/jailbreak1/colors1/karts1/firstplace1.mp3");

						else if (strFinishedPlayerNamesLength == 2)
							foreach (PlayerInGameSecond in PlayersInGame)
								EntFireByHandle(hClientCommand, "Command", "play berke1/jailbreak1/colors1/karts1/loser1.mp3", 0, PlayerInGameSecond.hPlayer, null);

						strFinishedPlayerNames.push(strPlayerName);
					}

					else
					{
						if (iLap == iLapLimit - 1)
						{
							PlayGlobalSound("berke1/jailbreak1/colors1/karts1/finallap1.mp3");

							EntFireByHandle(GetMusicPlayer(), "Pitch", "150", 0, null, null);
						}

						else
							EntFireByHandle(GetClientCommand(), "Command", "play berke1/jailbreak1/colors1/karts1/lap1.mp3", 0, hPlayer, null);

						PlayerInGame.iLap++, PlayerInGame.iCheckPoint = 1;
					}

					CheckPlacement();

					break;
				}

				case 5:
				{
					if (PlayerInGame.iLap > 1)
						PlayerInGame.iLap--, PlayerInGame.iCheckPoint = 6;

					CheckPlacement();
				}
			}

			break;
		}
	}
}

function StopGame()
{
	AddThinkToEnt(self, null);

	EntFireByHandle(GetButton(1), "Unlock", "", 0, null, null);

	EntFireByHandle(GetButton(2), "Lock", "", 0, null, null);

	EntFireByHandle(GetButton(3), "Unlock", "", 0, null, null);

	EntFireByHandle(GetButton(4), "Unlock", "", 0, null, null);

	local hMusicPlayer = GetMusicPlayer();

	EntFireByHandle(hMusicPlayer, "Pitch", "100", 0, null, null);

	EntFireByHandle(hMusicPlayer, "StopSound", "", 0, null, null);

	foreach (PlayerInGame in PlayersInGame)
		ExitPlayer(PlayerInGame.hPlayer);

	PlayersInGame.clear();
}

function ExitPlayer(hPlayer, bShouldUsePlacement = false)
{
	hPlayer.RemoveCond(Constants.ETFCond.TF_COND_HALLOWEEN_KART);

	local strFinishedPlayerNamesLength = strFinishedPlayerNames.len(), flOrigin = Vector(), flAngles = QAngle();

	if (bShouldUsePlacement && strFinishedPlayerNamesLength <= 2)
		flOrigin = flGamePlacementsOriginAngle[strFinishedPlayerNamesLength].flOrigin, flAngles = flGamePlacementsOriginAngle[strFinishedPlayerNamesLength].flAngles;

	else
	{
		local flGameEndOrigin = flGameEndOriginAngle.flOrigin;

		flOrigin = Vector(flGameEndOrigin.x + RandomInt(-32, 32), flGameEndOrigin.y + RandomInt(-32, 32), flGameEndOrigin.z);
	}

	hPlayer.SetAbsOrigin(flOrigin);
	hPlayer.SnapEyeAngles(QAngle(0, flAngles));
	hPlayer.SetAbsVelocity(Vector());

	DisplayMapMessage(hPlayer);
}

function GetClientCommand()
{
	return GetEntity(0, "clientcommand1");
}

function GetMusicPlayer()
{
	return GetEntity(1, "music1");
}

function GetWorldText(iNumber)
{
	return GetEntity(1 + iNumber, "worldtext" + iNumber);
}

function GetButton(iNumber)
{
	return GetEntity(3 + iNumber, "button" + iNumber);
}

function GetOrdinalNumberSuffix(iNumber)
{
	local strSuffix = "th";

	if (iNumber <= 3 || iNumber > 20)
		switch (iNumber % 10)
		{
			case 1:
			{
				strSuffix = "st";

				break;
			}

			case 2:
			{
				strSuffix = "nd";

				break;
			}

			case 3:
				strSuffix = "rd";
		}

	return strSuffix;
}

function DisplayMapMessage(hPlayer, strMessage = "")
{
	local hText = GetEntity(8, "text1");

	EntFireByHandle(hText, "AddOutput", "message " + strMessage, 0, hPlayer, null);

	EntFireByHandle(hText, "Display", "", 0, hPlayer, null);
}

function PlayGlobalSound(strSound)
{
	PrecacheSound(strSound);

	self.EmitSound(strSound);
}

function GetEntity(iOrder, strName)
{
	return hGameEntities[iOrder] ? hGameEntities[iOrder] : hGameEntities[iOrder] = Entities.FindByName(null, "karts1" + strName);
}

function PrintMapMessage(hPlayer, strMessage)
{
	ClientPrint(hPlayer, Constants.EHudNotify.HUD_PRINTTALK, "\x0700FF00[Map]\x1 " + strMessage);
}